## game-music-emu 0.5.5

=== CMakeLists.txt ===
# CMake project definition file.
project(libgme)

# 2.6+ always assumes FATAL_ERROR, but 2.4 and below don't.
# Of course, 2.4 might work, in which case you're welcome to drop
# down the requirement, but I can't test that.
cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

# Default emulators to build (all of them! ;)
if (NOT DEFINED USE_GME_AY)
    SET(USE_GME_AY 1 CACHE BOOL "Enable support for Spectrum ZX music emulation")
endif()

if (NOT DEFINED USE_GME_GBS)
    SET(USE_GME_GBS 1 CACHE BOOL "Enable support for Game Boy music emulation")
endif()

if (NOT DEFINED USE_GME_GYM)
    SET(USE_GME_GYM 1 CACHE BOOL "Enable Sega MegaDrive/Genesis music emulation")
endif()

if (NOT DEFINED USE_GME_HES)
    SET(USE_GME_HES 1 CACHE BOOL "Enable PC Engine/TurboGrafx-16 music emulation")
endif()

if (NOT DEFINED USE_GME_KSS)
    SET(USE_GME_KSS 1 CACHE BOOL "Enable MSX or other Z80 systems music emulation")
endif()

if (NOT DEFINED USE_GME_NSF)
    SET(USE_GME_NSF 1 CACHE BOOL "Enable NES NSF music emulation")
endif()

if (NOT DEFINED USE_GME_NSFE)
    SET(USE_GME_NSFE 1 CACHE BOOL "Enable NES NSFE and NSF music emulation")
endif()

if (NOT DEFINED USE_GME_SAP)
    SET(USE_GME_SAP 1 CACHE BOOL "Enable Atari SAP music emulation")
endif()

if (NOT DEFINED USE_GME_SPC)
    SET(USE_GME_SPC 1 CACHE BOOL "Enable SNES SPC music emulation")
endif()

if (NOT DEFINED USE_GME_VGM)
    SET(USE_GME_VGM 1 CACHE BOOL "Enable Sega VGM/VGZ music emulation")
endif()

if (USE_GME_NSFE AND NOT USE_GME_NSF)
    MESSAGE(" -- NSFE support requires NSF, enabling NSF support. --")
    SET(USE_GME_NSF 1 CACHE BOOL "Enable NES NSF music emulation" FORCE)
endif()

# Shared library defined here
add_subdirectory(gme)

# EXCLUDE_FROM_ALL adds build rules but keeps it out of default build
add_subdirectory(player EXCLUDE_FROM_ALL)
add_subdirectory(demo EXCLUDE_FROM_ALL)

=== demo/CMakeLists.txt ===
# Rules for building the demo.  Doesn't use an installed gme if you've already
# installed the project so if you're copying these rules you probably don't
# even need these next two lines if you're building against system-installed
# gme.
include_directories(${CMAKE_SOURCE_DIR}/gme ${CMAKE_SOURCE_DIR})
link_directories(${CMAKE_BINARY_DIR}/gme)

add_executable(demo Wave_Writer.cpp basics.c)

target_link_libraries(demo gme)

=== gme/CMakeLists.txt ===
# List of source files required by libgme and any emulators
# This is not 100% accurate (Fir_Resampler for instance) but
# you'll be OK.
set(libgme_SRCS Blip_Buffer.cpp
                Classic_Emu.cpp
                Data_Reader.cpp
                Dual_Resampler.cpp
                Effects_Buffer.cpp
                Fir_Resampler.cpp
                gme.cpp
                Gme_File.cpp
                M3u_Playlist.cpp
                Multi_Buffer.cpp
                Music_Emu.cpp
                )

# Ay_Apu is very popular around here
if (USE_GME_AY OR USE_GME_KSS)
    set(libgme_SRCS ${libgme_SRCS}
                Ay_Apu.cpp
        )
endif()

# so is Ym2612_Emu
if (USE_GME_VGM OR USE_GME_GYM)
    set(libgme_SRCS ${libgme_SRCS}
                Ym2612_Emu.cpp
        )
endif()

# But none are as popular as Sms_Apu
if (USE_GME_VGM OR USE_GME_GYM OR USE_GME_KSS)
    set(libgme_SRCS ${libgme_SRCS}
                Sms_Apu.cpp
        )
endif()

if (USE_GME_AY)
    set(libgme_SRCS ${libgme_SRCS}
              # Ay_Apu.cpp included earlier
                Ay_Cpu.cpp
                Ay_Emu.cpp
        )
endif()

if (USE_GME_GBS)
    set(libgme_SRCS ${libgme_SRCS}
                Gb_Apu.cpp
                Gb_Cpu.cpp
                Gb_Oscs.cpp
                Gbs_Emu.cpp
        )
endif()

if (USE_GME_GYM)
    set(libgme_SRCS ${libgme_SRCS}
              # Sms_Apu.cpp included earlier
              # Ym2612_Emu.cpp included earlier
                Gym_Emu.cpp
        )
endif()

if (USE_GME_HES)
    set(libgme_SRCS ${libgme_SRCS}
                Hes_Apu.cpp
                Hes_Cpu.cpp
                Hes_Emu.cpp
        )
endif()

if (USE_GME_KSS)
    set(libgme_SRCS ${libgme_SRCS}
              # Ay_Apu.cpp included earlier
              # Sms_Apu.cpp included earlier
                Kss_Cpu.cpp
                Kss_Emu.cpp
                Kss_Scc_Apu.cpp
        )
endif()

if (USE_GME_NSF OR USE_GME_NSFE)
    set(libgme_SRCS ${libgme_SRCS}
                Nes_Apu.cpp
                Nes_Cpu.cpp
                Nes_Fme7_Apu.cpp
                Nes_Namco_Apu.cpp
                Nes_Oscs.cpp
                Nes_Vrc6_Apu.cpp
                Nsf_Emu.cpp
        )
endif()

if (USE_GME_NSFE)
    set(libgme_SRCS ${libgme_SRCS}
                Nsfe_Emu.cpp
        )
endif()

if (USE_GME_SAP)
    set(libgme_SRCS ${libgme_SRCS}
                Sap_Apu.cpp
                Sap_Cpu.cpp
                Sap_Emu.cpp
        )
endif()

if (USE_GME_SPC)
    set(libgme_SRCS ${libgme_SRCS}
                Snes_Spc.cpp
                Spc_Cpu.cpp
                Spc_Dsp.cpp
                Spc_Emu.cpp
        )
endif()

if (USE_GME_VGM)
    set(libgme_SRCS ${libgme_SRCS}
              # Sms_Apu.cpp included earlier
              # Ym2612_Emu.cpp included earlier
                Vgm_Emu.cpp
                Vgm_Emu_Impl.cpp
                Ym2413_Emu.cpp
        )
endif()

# These headers are part of the generic gme interface.
set (EXPORTED_HEADERS gme.h
                      "${CMAKE_CURRENT_BINARY_DIR}/gme_types.h"
                      blargg_config.h
                      blargg_common.h
                      blargg_source.h
                      Music_Emu.h
                      Blip_Buffer.h
                      Classic_Emu.h
                      Gme_File.h
                      Data_Reader.h
                      Dual_Resampler.h
                      Effects_Buffer.h
                      Fir_Resampler.h
                      M3u_Playlist.h
                      Multi_Buffer.h)

# Run during cmake phase, so this is available during make
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gme_types.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/gme_types.h)

# For the gme_types.h
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# Add library to be compiled.
add_library(gme SHARED ${libgme_SRCS})

# The version is the release.  The "soversion" is the API version.  As long
# as only build fixes are performed (i.e. no changes/additions to API) the
# SOVERSION should be the same even when bumping up VERSION.
set_target_properties(gme
    PROPERTIES VERSION 0.5.3
               SOVERSION 0)

# TODO: Libsuffix for 64-bit?
install(TARGETS gme LIBRARY DESTINATION lib)

install(FILES ${EXPORTED_HEADERS} DESTINATION include/gme)

=== debian/changelog ===
game-music-emu (0.5.5-2) unstable; urgency=low

  * debian/control,
    debian/compat,
    debian/source/format,
    debian/rules:
    + Update to source format 3.0 (quilt).
    + Update Standards-Version to 3.8.4.
    + Update to debhelper compat level 7.
  * debian/patches/01_symbol-exports.patch:
    + Only export symbols that are meant to be public. Patch
      from upstream SVN.
  * debian/libgme0.symbols:
    + Add symbols file.

 -- Sebastian Dröge <slomo@debian.org>  Mon, 22 Mar 2010 14:29:59 +0100

game-music-emu (0.5.5-1) unstable; urgency=low

  * Initial upload (Closes: #540480).

 -- Sebastian Dröge <slomo@debian.org>  Sat, 08 Aug 2009 10:37:12 +0200

=== debian/control ===
Source: game-music-emu
Section: sound
Priority: optional
Maintainer: Sebastian Dröge <slomo@debian.org>
Build-Depends: debhelper (>= 7),
               cmake (>= 2.6.0)
Standards-Version: 3.8.4
Homepage: http://code.google.com/p/game-music-emu

Package: libgme0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Playback library for video game music files - shared library
 game-music-emu is a collection of video game music file emulators that
 support the following formats and systems:
  * AY        ZX Spectrum/Amstrad CPC
  * GBS       Nintendo Game Boy
  * GYM       Sega Genesis/Mega Drive
  * HES       NEC TurboGrafx-16/PC Engine
  * KSS       MSX Home Computer/other Z80 systems (doesn't support FM sound)
  * NSF/NSFE  Nintendo NES/Famicom (with VRC 6, Namco 106, and FME-7 sound)
  * SAP       Atari systems using POKEY sound chip
  * SPC       Super Nintendo/Super Famicom
  * VGM/VGZ   Sega Master System/Mark III, Sega Genesis/Mega Drive,BBC Micro
 .
 This package contains the shared libraries necessary to run programs
 using libgme.

Package: libgme-dev
Architecture: any
Section: libdevel
Depends: libgme0 (= ${binary:Version}),
         ${misc:Depends}
Description: Playback library for video game music files - development files
 game-music-emu is a collection of video game music file emulators that
 support the following formats and systems:
  * AY        ZX Spectrum/Amstrad CPC
  * GBS       Nintendo Game Boy
  * GYM       Sega Genesis/Mega Drive
  * HES       NEC TurboGrafx-16/PC Engine
  * KSS       MSX Home Computer/other Z80 systems (doesn't support FM sound)
  * NSF/NSFE  Nintendo NES/Famicom (with VRC 6, Namco 106, and FME-7 sound)
  * SAP       Atari systems using POKEY sound chip
  * SPC       Super Nintendo/Super Famicom
  * VGM/VGZ   Sega Master System/Mark III, Sega Genesis/Mega Drive,BBC Micro
 .
 This package contains the header files, static libraries
 and symbolic links that developers using libgme will need.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

## game-music-emu 0.6.0

=== player/CMakeLists.txt ===
find_package(SDL QUIET)

set(player_SRCS Audio_Scope.cpp
                Audio_Scope.h
                Music_Player.cpp
                Music_Player.h
                player.cpp)

if(SDL_FOUND)
    message(" ** SDL library located, player demo is available to be built in the /player directory")

    include_directories(${SDL_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}
        "${CMAKE_HOME_DIRECTORY}" "${CMAKE_HOME_DIRECTORY}/gme"
        "${CMAKE_BINARY_DIR}/gme")

    add_executable(gme_player ${player_SRCS})
    target_link_libraries(gme_player ${SDL_LIBRARY} gme)

    # Is not to be installed though
else()
    message("SDL library not found, disabling player demo build")
endif()

=== debian/changelog ===
game-music-emu (0.6.0-3ubuntu0.16.04.1) xenial-security; urgency=medium

  * SECURITY UPDATE: code execution via missing register value clamps
    - debian/patches/missing_register_value_clamp.patch: clamp values to
      uint8_t in gme/Spc_Cpu.h.
    - No CVE number

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 13 Dec 2016 11:37:51 -0500

game-music-emu (0.6.0-3) unstable; urgency=medium

  * debian/patches/03_link-zlib.patch:
    + Link the library with zlib as required.

 -- Sebastian Dröge <slomo@debian.org>  Sat, 26 Sep 2015 11:05:22 +0200

game-music-emu (0.6.0-2) unstable; urgency=medium

  * debian/control,
    debian/copyright:
    + Fix homepage URL to point to bitbucket too.

 -- Sebastian Dröge <slomo@debian.org>  Sat, 19 Sep 2015 18:51:44 +0200

game-music-emu (0.6.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch:
    + Fix watch file for new home of the project at github (Closes: #698177).
  * debian/patches/01_enable-zlib.patch,
    debian/patches/02_zlib-compiler-warnings.patch:
    + Enable zlib support (Closes: #640287).

 -- Sebastian Dröge <slomo@debian.org>  Sat, 19 Sep 2015 18:08:53 +0200

game-music-emu (0.5.5-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add multi-arch support based on a patch by Francois Gouget (Closes:
    #777070)
    + debian/control: Bump B-D on debhelper to (>= 9) and add M-A: same.
    + debian/compat: Bump to 9.
    + debian/libgme0.install, debian/libgme-dev.install: Update for new paths.
    + debian/rules: Move files to multi-arch location.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 22 Jul 2015 23:59:08 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,19 @@
 Source: game-music-emu
 Section: sound
 Priority: optional
-Maintainer: Sebastian Dröge <slomo@debian.org>
-Build-Depends: debhelper (>= 7),
-               cmake (>= 2.6.0)
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sebastian Dröge <slomo@debian.org>
+Build-Depends: debhelper (>= 9),
+               cmake (>= 2.6.0),
+               zlib1g-dev
 Standards-Version: 3.8.4
-Homepage: http://code.google.com/p/game-music-emu
+Homepage: https://bitbucket.org/mpyne/game-music-emu/wiki/Home
 
 Package: libgme0
 Architecture: any
+Multi-Arch: same
 Section: libs
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: Playback library for video game music files - shared library
@@ -30,6 +34,7 @@
 
 Package: libgme-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: libgme0 (= ${binary:Version}),
          ${misc:Depends}

## game-music-emu 0.6.1

=== debian/changelog ===
game-music-emu (0.6.1-1) unstable; urgency=medium

  * New upstream bugfix release:
    + debian/patches/02_zlib-compiler-warnings.patch,
      debian/patches/04_spc-out-of-bounds-reads-writes.patch:
      - Dropped, merged upstream.
    + debian/libgme0.symbols:
      - Add new symbols.

 -- Sebastian Dröge <slomo@debian.org>  Mon, 30 Jan 2017 19:10:39 +0200

game-music-emu (0.6.0-4) unstable; urgency=high

  * debian/patches/04_spc-out-of-bounds-reads-writes.patch:
    + Fix out of bound reads/writes with security implications (Closes: #848071).
      Patch provided by Chris Evans at
      https://scarybeastsecurity.blogspot.gr/2016/12/redux-compromising-linux-using-snes.html

 -- Sebastian Dröge <slomo@debian.org>  Wed, 14 Dec 2016 09:17:02 +0200

## game-music-emu 0.6.2

=== debian/changelog ===
game-music-emu (0.6.2-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:14:34 +0100

game-music-emu (0.6.2-1) unstable; urgency=high

  * New upstream bugfix release
    + Fixes usage of negative size parameter passed to memcpy() on
      specially crafted files (Closes: #883691, CVE-2017-17446).

 -- Sebastian Dröge <slomo@debian.org>  Thu, 07 Dec 2017 10:03:19 +0200

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH) 

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	mkdir debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/libgme.so* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

## game-music-emu 0.6.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,10 @@
 # CMake project definition file.
 project(libgme)
+
+include (CheckCXXCompilerFlag)
+
+# When version is changed, also change the one in gme/gme.h to match
+set(GME_VERSION 0.6.3 CACHE INTERNAL "libgme Version")
 
 # 2.6+ always assumes FATAL_ERROR, but 2.4 and below don't.
 # Of course, 2.4 might work, in which case you're welcome to drop
@@ -43,8 +48,16 @@
     SET(USE_GME_SPC 1 CACHE BOOL "Enable SNES SPC music emulation")
 endif()
 
+if (NOT DEFINED GME_SPC_ISOLATED_ECHO_BUFFER)
+    option(GME_SPC_ISOLATED_ECHO_BUFFER "Enable isolated echo buffer on SPC emulator to allow correct playing of \"dodgy\" SPC files made for various ROM hacks ran on ZSNES" OFF)
+endif()
+
 if (NOT DEFINED USE_GME_VGM)
     SET(USE_GME_VGM 1 CACHE BOOL "Enable Sega VGM/VGZ music emulation")
+endif()
+
+if (NOT DEFINED GME_YM2612_EMU)
+    SET(GME_YM2612_EMU "Nuked" CACHE STRING "Which YM2612 emulator to use: \"Nuked\" (LGPLv2.1+), \"MAME\" (GPLv2+), or \"GENS\" (LGPLv2.1+)")
 endif()
 
 if (USE_GME_NSFE AND NOT USE_GME_NSF)
@@ -52,6 +65,39 @@
     SET(USE_GME_NSF 1 CACHE BOOL "Enable NES NSF music emulation" FORCE)
 endif()
 
+option(BUILD_SHARED_LIBS "Build shared library (set to OFF for static library)" ON)
+
+option(ENABLE_UBSAN "Enable Undefined Behavior Sanitizer error-checking" ON)
+
+option(BUILD_FRAMEWORK "Build framework instead of dylib (on macOS)" OFF)
+
+# Check for GCC/Clang "visibility" support.
+if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
+    OR
+    CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+
+    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -W -Wextra")
+    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+
+    # Assume we have visibility support on any compiler that supports C++11
+    add_definitions (-DLIBGME_VISIBILITY)
+    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden -fvisibility-inlines-hidden")
+
+    # Try to protect against undefined behavior from signed integer overflow
+    # This has caused miscompilation of code already and there are other
+    # potential uses; see https://bitbucket.org/mpyne/game-music-emu/issues/18/
+    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fwrapv")
+
+    if (ENABLE_UBSAN)
+        # GCC needs -static-libubsan
+        if (NOT BUILD_SHARED_LIBS AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
+            set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined -static-libubsan")
+        else()
+            set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined")
+        endif()
+    endif()
+endif ()
+
 # Shared library defined here
 add_subdirectory(gme)

=== demo/CMakeLists.txt ===
--- 
+++ 
@@ -7,4 +7,22 @@
 
 add_executable(demo Wave_Writer.cpp basics.c)
 
+# Add command to copy build file over.
+add_custom_command(TARGET demo
+    POST_BUILD
+    COMMAND cmake -E copy "${CMAKE_SOURCE_DIR}/test.nsf" ${CMAKE_CURRENT_BINARY_DIR}
+    COMMENT "Add convenience copy of test.nsf file for demo application"
+    VERBATIM) # VERBATIM is essentially required, "please use correct command line kthx"
+
 target_link_libraries(demo gme)
+
+
+add_executable(demo_mem Wave_Writer.cpp basics_mem.c)
+
+add_custom_command(TARGET demo_mem
+    POST_BUILD
+    COMMAND cmake -E copy "${CMAKE_SOURCE_DIR}/test.vgz" ${CMAKE_CURRENT_BINARY_DIR}
+    COMMENT "Add convenience copy of test.nsf file for demo application"
+    VERBATIM) # VERBATIM is essentially required, "please use correct command line kthx"
+
+target_link_libraries(demo_mem gme)

=== gme/CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,15 @@
                 Music_Emu.cpp
                 )
 
+# static builds need to find static zlib (and static forms of other needed
+# libraries.  Ensure CMake looks only for static libs if we're doing a static
+# build.  See https://stackoverflow.com/a/44738756
+if(NOT BUILD_SHARED_LIBS)
+    set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
+endif()
+
+find_package(ZLIB QUIET)
+
 # Ay_Apu is very popular around here
 if (USE_GME_AY OR USE_GME_KSS)
     set(libgme_SRCS ${libgme_SRCS}
@@ -23,9 +32,25 @@
 
 # so is Ym2612_Emu
 if (USE_GME_VGM OR USE_GME_GYM)
-    set(libgme_SRCS ${libgme_SRCS}
-                Ym2612_Emu.cpp
-        )
+    if(GME_YM2612_EMU STREQUAL "Nuked")
+        add_definitions(-DVGM_YM2612_NUKED)
+        set(libgme_SRCS ${libgme_SRCS}
+                    Ym2612_Nuked.cpp
+            )
+        message("VGM/GYM: Nuked OPN2 emulator will be used")
+    elseif(GME_YM2612_EMU STREQUAL "MAME")
+        add_definitions(-DVGM_YM2612_MAME)
+        set(libgme_SRCS ${libgme_SRCS}
+                    Ym2612_MAME.cpp
+            )
+        message("VGM/GYM: MAME YM2612 emulator will be used")
+    else()
+        add_definitions(-DVGM_YM2612_GENS)
+        set(libgme_SRCS ${libgme_SRCS}
+                    Ym2612_GENS.cpp
+            )
+        message("VGM/GYM: GENS 2.10 emulator will be used")
+    endif()
 endif()
 
 # But none are as popular as Sms_Apu
@@ -110,7 +135,11 @@
                 Spc_Cpu.cpp
                 Spc_Dsp.cpp
                 Spc_Emu.cpp
-        )
+                Spc_Filter.cpp
+        )
+    if (GME_SPC_ISOLATED_ECHO_BUFFER)
+        add_definitions(-DSPC_ISOLATED_ECHO_BUFFER)
+    endif()
 endif()
 
 if (USE_GME_VGM)
@@ -124,40 +153,69 @@
 endif()
 
 # These headers are part of the generic gme interface.
-set (EXPORTED_HEADERS gme.h
-                      "${CMAKE_CURRENT_BINARY_DIR}/gme_types.h"
-                      blargg_config.h
-                      blargg_common.h
-                      blargg_source.h
-                      Music_Emu.h
-                      Blip_Buffer.h
-                      Classic_Emu.h
-                      Gme_File.h
-                      Data_Reader.h
-                      Dual_Resampler.h
-                      Effects_Buffer.h
-                      Fir_Resampler.h
-                      M3u_Playlist.h
-                      Multi_Buffer.h)
+set (EXPORTED_HEADERS gme.h blargg_source.h)
+
+# while building a macOS framework, exported headers must be in the source
+# list, or the header files aren't copied to the bundle.
+if (BUILD_FRAMEWORK)
+    set(libgme_SRCS ${libgme_SRCS} ${EXPORTED_HEADERS})
+endif()
+
+# On some platforms we may need to change headers or whatnot based on whether
+# we're building the library or merely using the library. The following is
+# only defined when building the library to allow us to tell which is which.
+add_definitions(-DBLARGG_BUILD_DLL)
+
+# For the gme_types.h
+include_directories(${CMAKE_CURRENT_BINARY_DIR})
+
+# Add library to be compiled.
+add_library(gme ${libgme_SRCS})
+
+if(ZLIB_FOUND)
+    message(" ** ZLib library located, compressed file formats will be supported")
+    target_compile_definitions(gme PRIVATE -DHAVE_ZLIB_H)
+    target_include_directories(gme PRIVATE ${ZLIB_INCLUDE_DIRS})
+    target_link_libraries(gme ${ZLIB_LIBRARIES})
+    # Is not to be installed though
+
+    set(PKG_CONFIG_ZLIB -lz) # evaluated in libgme.pc.in
+else()
+    message("ZLib library not found, disabling support for compressed formats such as VGZ")
+endif()
+
+# The version is the release.  The "soversion" is the API version.  As long
+# as only build fixes are performed (i.e. no backwards-incompatible changes
+# to the API), the SOVERSION should be the same even when bumping up VERSION.
+# The way gme.h is designed, SOVERSION should very rarely be bumped, if ever.
+# Hopefully the API can stay compatible with old versions.
+set_target_properties(gme
+    PROPERTIES VERSION ${GME_VERSION}
+               SOVERSION 0)
+
+# macOS framework build
+if(BUILD_FRAMEWORK)
+    set_target_properties(gme
+        PROPERTIES FRAMEWORK TRUE
+                   FRAMEWORK_VERSION A
+                   MACOSX_FRAMEWORK_IDENTIFIER net.mpyne.gme
+                   VERSION ${GME_VERSION}
+                   SOVERSION 0
+                   PUBLIC_HEADER "${EXPORTED_HEADERS}")
+endif()
+
+install(TARGETS gme LIBRARY DESTINATION lib${LIB_SUFFIX}
+                    RUNTIME DESTINATION bin  # DLL platforms
+                    ARCHIVE DESTINATION lib # DLL platforms
+                    FRAMEWORK DESTINATION /Library/Frameworks) # macOS framework
+
 
 # Run during cmake phase, so this is available during make
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gme_types.h.in
     ${CMAKE_CURRENT_BINARY_DIR}/gme_types.h)
 
-# For the gme_types.h
-include_directories(${CMAKE_CURRENT_BINARY_DIR})
-
-# Add library to be compiled.
-add_library(gme SHARED ${libgme_SRCS})
-
-# The version is the release.  The "soversion" is the API version.  As long
-# as only build fixes are performed (i.e. no changes/additions to API) the
-# SOVERSION should be the same even when bumping up VERSION.
-set_target_properties(gme
-    PROPERTIES VERSION 0.5.3
-               SOVERSION 0)
-
-# TODO: Libsuffix for 64-bit?
-install(TARGETS gme LIBRARY DESTINATION lib)
+configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libgme.pc.in
+    ${CMAKE_CURRENT_BINARY_DIR}/libgme.pc @ONLY)
 
 install(FILES ${EXPORTED_HEADERS} DESTINATION include/gme)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libgme.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)

=== player/CMakeLists.txt ===
find_package(SDL2)

set(player_SRCS Audio_Scope.cpp
                Audio_Scope.h
                Music_Player.cpp
                Music_Player.h
                player.cpp)

if(SDL2_FOUND)
    message(" ** SDL 2 library located, player demo is available to be built in the /player directory")

    include_directories(${SDL2_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR}
        "${CMAKE_HOME_DIRECTORY}" "${CMAKE_HOME_DIRECTORY}/gme"
        "${CMAKE_BINARY_DIR}/gme")

    add_executable(gme_player ${player_SRCS})
    target_link_libraries(gme_player ${SDL2_LIBRARIES} gme)

    # Is not to be installed though
else()
    message("SDL library not found, disabling player demo build")
endif()

=== debian/changelog ===
game-music-emu (0.6.3-2) unstable; urgency=medium

  * debian/libgme0.symbols:
    + Add some regexes for the C++ specific symbols to fix build failure on 32
      bit architectures.
  * debian/rules:
    + Don't enable ubsan support, for whatever reason it's enabled by default.

 -- Sebastian Dröge <slomo@debian.org>  Fri, 17 Apr 2020 19:16:56 +0300

game-music-emu (0.6.3-1) unstable; urgency=medium

  * New upstream release
    + Drop all patches as they're not needed anymore.
  * debian/watch:
    + Update watch file syntax.
  * debian/libgme0.symbols:
    + Add new symbols.
    + Make some symbols optional to fix build with GCC 10 (Closes: #957252).
  * debian/rules,
    debian/control,
    debian/compat:
    + Fix various lintian warnings.
    + Ship pkg-config file.
    + Update to debhelper compat version 12 and standards version 4.5.0.

 -- Sebastian Dröge <slomo@debian.org>  Fri, 17 Apr 2020 14:29:33 +0300

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: game-music-emu
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sebastian Dröge <slomo@debian.org>
-Build-Depends: debhelper (>= 9),
-               cmake (>= 2.6.0),
+Maintainer: Sebastian Dröge <slomo@debian.org>
+Build-Depends: debhelper (>= 12),
+               debhelper-compat (= 12),
+               cmake (>= 2.6),
                zlib1g-dev
-Standards-Version: 3.8.4
+Standards-Version: 4.5.0
 Homepage: https://bitbucket.org/mpyne/game-music-emu/wiki/Home
 
 Package: libgme0

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_UBSAN=OFF

override_dh_auto_install:
	dh_auto_install
	mkdir debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/libgme.so* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/pkgconfig debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

=== debian/watch ===
version=4
https://bitbucket.org/mpyne/game-music-emu/downloads/ game-music-emu-([\d\.]+)\.tar\.xz

## game-music-emu 0.6.3.2

=== debian/changelog ===
game-music-emu (0.6.3.2-7deepin) unstable; urgency=medium

  * Existing version 0.6.3.1-deepin1+rb2 > 0.6.3.1-7deepin 

 -- LiChengGang <lichenggang@uniontech.com>  Wed, 03 Jan 2024 21:32:34 +0800

game-music-emu (0.6.3.1-7deepin) unstable; urgency=medium

  * update changelog.

 -- LiChengGang <lichenggang@uniontech.com>  Tue, 02 Jan 2024 16:44:07 +0800

game-music-emu (0.6.3-7) unstable; urgency=medium

  * Replace abandoned Bitbucket upstream for active Github upstream.
  * d/watch: Point to new upstream repository.
  * d/control: Update homepage.
  * d/copyright: Update source and upstream contact.
  * d/upstream/metadata: Update upstream metadata.
  * d/gbp.conf: Pull and commit to pristine-tar branch.

 -- Ileana Dumitrescu <ileanadumitrescu95@gmail.com>  Thu, 02 Nov 2023 19:21:00 +0200

game-music-emu (0.6.3-6) unstable; urgency=medium

  * debian/upstream/metadata: New file
  * debian/control: Bump Standards-Version to 4.6.2
  * debian/copyright: Update debian copyright year
  * debian/rules: Add hardening flag

 -- Ileana Dumitrescu <ileanadumitrescu95@gmail.com>  Mon, 30 Jan 2023 15:36:36 +0200

game-music-emu (0.6.3-5) unstable; urgency=medium

  * debian/libgme0.symbols: Fix for 32/64 bit arch (Closes: #1024363)
  * debian/control: Add salsa repository location

 -- Ileana Dumitrescu <ileanadumitrescu95@gmail.com>  Tue, 22 Nov 2022 15:39:44 +0200

game-music-emu (0.6.3-4) unstable; urgency=medium

  * debian/control:
    + Adopt package (Closes: #1018069)
    + Update debhelper, debhelper-compat version to 13
    + Add Rules-Requires-Root line
    + Bump Standards-Version to 4.6.1
  * debian/copyright: Update to dep5 format
  * debian/libgme0.symbols: Removed lines from diff output

 -- Ileana Dumitrescu <ileanadumitrescu95@gmail.com>  Thu, 17 Nov 2022 14:59:50 +0200

game-music-emu (0.6.3-3) unstable; urgency=medium

  * QA upload.
  * Set Maintainer to Debian QA Group.  (See: #1018069)
  * Update symbols file for GCC 12, thanks to Étienne Mollier.
    (Closes: #1012932)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 30 Oct 2022 01:22:59 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,16 @@
 Source: game-music-emu
 Section: sound
 Priority: optional
-Maintainer: Sebastian Dröge <slomo@debian.org>
-Build-Depends: debhelper (>= 12),
-               debhelper-compat (= 12),
+Maintainer: Ileana Dumitrescu <ileanadumitrescu95@gmail.com>
+Build-Depends: debhelper (>= 13),
+               debhelper-compat (= 13),
                cmake (>= 2.6),
                zlib1g-dev
-Standards-Version: 4.5.0
-Homepage: https://bitbucket.org/mpyne/game-music-emu/wiki/Home
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
+Homepage: https://github.com/libgme/game-music-emu
+Vcs-Browser: https://salsa.debian.org/debian/game-music-emu
+Vcs-Git: https://salsa.debian.org/debian/game-music-emu.git
 
 Package: libgme0
 Architecture: any
@@ -27,7 +30,7 @@
   * NSF/NSFE  Nintendo NES/Famicom (with VRC 6, Namco 106, and FME-7 sound)
   * SAP       Atari systems using POKEY sound chip
   * SPC       Super Nintendo/Super Famicom
-  * VGM/VGZ   Sega Master System/Mark III, Sega Genesis/Mega Drive,BBC Micro
+  * VGM/VGZ   Sega Master System/Mark III, Sega Genesis/Mega Drive, BBC Micro
  .
  This package contains the shared libraries necessary to run programs
  using libgme.
@@ -49,8 +52,7 @@
   * NSF/NSFE  Nintendo NES/Famicom (with VRC 6, Namco 106, and FME-7 sound)
   * SAP       Atari systems using POKEY sound chip
   * SPC       Super Nintendo/Super Famicom
-  * VGM/VGZ   Sega Master System/Mark III, Sega Genesis/Mega Drive,BBC Micro
+  * VGM/VGZ   Sega Master System/Mark III, Sega Genesis/Mega Drive, BBC Micro
  .
  This package contains the header files, static libraries
  and symbolic links that developers using libgme will need.
-
